/*
 * AllTypes.cpp
 *
 * Generated by SILECS framework tools. Will be overwritten on regeneration.
 */
 
#include <AllTypes/Common/AllTypes.h>
#include <silecs-communication/interface/utility/SilecsException.h>
#include <fesa-core/Synchronization/NoneContext.h>
#include <fesa-core/Synchronization/MultiplexingContext.h>
 
namespace AllTypes
{
    //Global objects of the SILECS class
    Silecs::Service* AbstractAllTypes::pService_ = NULL;
    Silecs::PLCHandler* AbstractAllTypes::pPLCHandler_ = NULL;
    bool AbstractAllTypes::isInitialized_ = false;
    MyROBlock_Type	AllTypes::MyROBlock("MyROBlock");
    MyRWBlock_Type	AllTypes::MyRWBlock("MyRWBlock");
    MyWOBlock_Type	AllTypes::MyWOBlock("MyWOBlock");
    MyCBlock_Type	AllTypes::MyCBlock("MyCBlock");
    
    //-------------------------------------------------------------------------------------------------------------
    // Constructor & Destructor methods
    
    AbstractAllTypes::AbstractAllTypes(std::string blockName): blockName_(blockName) {}
    AbstractAllTypes::~AbstractAllTypes() {}
    
    MyROBlock_Type::MyROBlock_Type(std::string name): AbstractAllTypes(name) {}
    MyROBlock_Type::~MyROBlock_Type() {}
    
    MyRWBlock_Type::MyRWBlock_Type(std::string name): AbstractAllTypes(name) {}
    MyRWBlock_Type::~MyRWBlock_Type() {}
    
    MyWOBlock_Type::MyWOBlock_Type(std::string name): AbstractAllTypes(name) {}
    MyWOBlock_Type::~MyWOBlock_Type() {}
    
    MyCBlock_Type::MyCBlock_Type(std::string name): AbstractAllTypes(name) {}
    MyCBlock_Type::~MyCBlock_Type() {}
    
    //---------------------------------------------------------------------------------------------------------
    // Set-up the SILECS components for the AbstractAllTypes class (service & plchandler)

    void AbstractAllTypes::setup(const ServiceLocator* serviceLocator)
    {
        try
        {
            // Instantiate the singleton of the SILECS Service
            pService_ = Silecs::Service::getInstance();

            // Enable the SILECS diagnostic with user topics if any
            pService_->setArguments(serviceLocator->getUsrCmdArgs());

            GlobalDevice* pGlobalDevice = serviceLocator->getGlobalDevice();
            pPLCHandler_ = &pService_->getPLCHandler();
            isInitialized_ = true;

            // Connect each PLC of the PLCHandler that is referred from the FESA instance
            std::vector<Device*> pDeviceCol = serviceLocator->getDeviceCollection();
            for(std::vector<Device*>::iterator pDeviceIter=pDeviceCol.begin(); pDeviceIter!= pDeviceCol.end(); pDeviceIter++)
            {
                Device* pDevice = *pDeviceIter;

                // Retrieve the PLC related to the current FESA device
                // (from 'plcHostName' FESA field defined on that purpose).
                Silecs::PLC* pPLC = &pPLCHandler_->getPLC(pDevice->plcHostName.get());

                // Update PLC registers from related FESA fields just before synchronising done at connection time
                updatePLCRegisters(pPLC, serviceLocator);

                // Connect the PLC if not already connected
                if (!pPLC->isEnabled())
                {   pPLC->connect(/*connectNow=*/true);
                    if (pPLC->isConnected())
                        updateFesaFields(pPLC, serviceLocator);
                }
            }
        }
        catch (const Silecs::SilecsException& ex)
        {
            throw fesa::FesaException(__FILE__, __LINE__, ex.getMessage());
        }
    }

    //---------------------------------------------------------------------------------------------------------
    // Release all the SILECS resources
    void AbstractAllTypes::cleanup()
    {
        // Attention! This method is responsible to stop all the PLC connections
        // and to remove all the SILECS resources (PLCs, Devices, Registers, ..)
        // Calling method must ensure that no process is currently accessing these resources before cleaning.
        //
        Silecs::Service::deleteInstance();
    }

    //---------------------------------------------------------------------------------------------------------
    //automatically called by the setup method at connection time)
    void AbstractAllTypes::updatePLCRegisters(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator)
    {
        fesa::NoneContext noneContext;
    
        AllTypes::MyCBlock.setPLCDevices(pPLC, serviceLocator, false, &noneContext);
    }

    //---------------------------------------------------------------------------------------------------------
    //automatically called by the setup method at connection time)
    void AbstractAllTypes::updateFesaFields(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator)
    {
        fesa::NoneContext noneContext;
    
        AllTypes::MyROBlock.getPLCDevices(pPLC, serviceLocator, false, &noneContext);
        AllTypes::MyRWBlock.getPLCDevices(pPLC, serviceLocator, false, &noneContext);
    }

    
    //---------------------------------------------------------------------------------------------------------
    // General methods to synchronize the FESA fields and related PLC registers of the FESA server
    // with or without PLC side access (send/recv) if requested.
    // get_ : [receive block from PLC +] update FESA fields with related PLC registers
    // set_ : update PLC registers with related FESA fields [+ send block to PLC]

    //---------------------------------------------------------------------------------------------------------

    void AbstractAllTypes::getAllDevices(const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext)
    {
        if (recvNow) thePLCHandler()->recv(blockName_);

        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {  getOneDevice(*pDeviceIter, false, pContext);
        }
    }

    void AbstractAllTypes::getPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, const bool recvNow, MultiplexingContext* pContext)
    {
        if (recvNow) pPLC->recv(blockName_);

        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {   if ((*pDeviceIter)->plcHostName.get() == pPLC->getName())
            {  getOneDevice(*pDeviceIter, false, pContext);
            }
        }
    }

    void AbstractAllTypes::getSomeDevices(std::vector<Device*> deviceCol, const bool sendNow, MultiplexingContext* pContext)
    {
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {    getOneDevice(*pDeviceIter, sendNow, pContext);
        }
    }

    void AbstractAllTypes::getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext) {};

    //---------------------------------------------------------------------------------------------------------

    void AbstractAllTypes::setAllDevices(const ServiceLocator* serviceLocator, bool sendNow, MultiplexingContext* pContext)
    {
        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {  setOneDevice(*pDeviceIter, false, pContext);
        }

        if (sendNow) thePLCHandler()->send(blockName_);
    }

    void AbstractAllTypes::setPLCDevices(Silecs::PLC* pPLC, const ServiceLocator* serviceLocator, bool sendNow, MultiplexingContext* pContext)
    {
        std::vector<Device*> deviceCol = serviceLocator->getDeviceCollection();
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {   if ((*pDeviceIter)->plcHostName.get() == pPLC->getName())
            {  setOneDevice(*pDeviceIter, false, pContext);
            }
        }

        if (sendNow) pPLC->send(blockName_);
    }

    void AbstractAllTypes::setSomeDevices(std::vector<Device*> deviceCol, bool sendNow, MultiplexingContext* pContext)
    {
        for(std::vector<Device*>::iterator pDeviceIter=deviceCol.begin(); pDeviceIter!= deviceCol.end(); pDeviceIter++)
        {    setOneDevice(*pDeviceIter, sendNow, pContext);
        }
    }

    void AbstractAllTypes::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext) {};
    
    void AbstractAllTypes::checkInitialized()
    {
        if( !isInitialized_ )
        {
            throw fesa::FesaException(__FILE__, __LINE__, "SILECS-Service not initialized yet - "
                "AllTypes::setup needs to be called before any plc-interaction can be done");
        }
    };

    //---------------------------------------------------------------------------------------------------------
    
    void MyROBlock_Type::getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC  = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        if (recvNow) pPLCDevice -> recv(blockName_);
    
        pDevice->RO_int8.set( pPLCDevice->getRegister("RO_int8")->getVal<int8_t>(), pContext);
        pDevice->RO_uint8_fesa.set( pPLCDevice->getRegister("RO_uint8")->getVal<uint8_t>(), pContext);
        pDevice->RO_int16_fesa.set( pPLCDevice->getRegister("RO_int16")->getVal<int16_t>(), pContext);
        pDevice->RO_uint16_fesa.set( pPLCDevice->getRegister("RO_uint16")->getVal<uint16_t>(), pContext);
        pDevice->RO_int32_fesa.set( pPLCDevice->getRegister("RO_int32")->getVal<int32_t>(), pContext);
        pDevice->RO_uint32_fesa.set( pPLCDevice->getRegister("RO_uint32")->getVal<uint32_t>(), pContext);
        pDevice->RO_float32_fesa.set( pPLCDevice->getRegister("RO_float32")->getVal<float>(), pContext);
        {
            auto& pRegister = pPLCDevice->getRegister("RO_string");
            pDevice->RO_string_fesa.set(pRegister->getVal<std::string>().c_str(), pContext);
        }

        pDevice->RO_date_fesa.set( pPLCDevice->getRegister("RO_date")->getVal<double>(), pContext);
        pDevice->RO_char_fesa.set( pPLCDevice->getRegister("RO_char")->getVal<int8_t>(), pContext);
        pDevice->RO_byte_fesa.set( pPLCDevice->getRegister("RO_byte")->getVal<uint8_t>(), pContext);
        pDevice->RO_word_fesa.set( pPLCDevice->getRegister("RO_word")->getVal<uint16_t>(), pContext);
        pDevice->RO_dword_fesa.set( pPLCDevice->getRegister("RO_dword")->getVal<uint32_t>(), pContext);
        pDevice->RO_int_fesa.set( pPLCDevice->getRegister("RO_int")->getVal<int16_t>(), pContext);
        pDevice->RO_dint_fesa.set( pPLCDevice->getRegister("RO_dint")->getVal<int32_t>(), pContext);
        pDevice->RO_real_fesa.set( pPLCDevice->getRegister("RO_real")->getVal<float>(), pContext);
        pDevice->RO_dt_fesa.set( pPLCDevice->getRegister("RO_dt")->getVal<double>(), pContext);
    }

    void MyRWBlock_Type::getOneDevice(Device* pDevice, const bool recvNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC  = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        if (recvNow) pPLCDevice -> recv(blockName_);
    
        pDevice->RW_int8.set( pPLCDevice->getRegister("RW_int8")->getVal<int8_t>(), pContext);
        pDevice->RW_uint8_fesa.set( pPLCDevice->getRegister("RW_uint8")->getVal<uint8_t>(), pContext);
        pDevice->RW_int16_fesa.set( pPLCDevice->getRegister("RW_int16")->getVal<int16_t>(), pContext);
        pDevice->RW_uint16_fesa.set( pPLCDevice->getRegister("RW_uint16")->getVal<uint16_t>(), pContext);
        pDevice->RW_int32_fesa.set( pPLCDevice->getRegister("RW_int32")->getVal<int32_t>(), pContext);
        pDevice->RW_uint32_fesa.set( pPLCDevice->getRegister("RW_uint32")->getVal<uint32_t>(), pContext);
        pDevice->RW_float32_fesa.set( pPLCDevice->getRegister("RW_float32")->getVal<float>(), pContext);
        {
            auto& pRegister = pPLCDevice->getRegister("RW_string");
            pDevice->RW_string_fesa.set(pRegister->getVal<std::string>().c_str(), pContext);
        }

        pDevice->RW_date_fesa.set( pPLCDevice->getRegister("RW_date")->getVal<double>(), pContext);
        pDevice->RW_char_fesa.set( pPLCDevice->getRegister("RW_char")->getVal<int8_t>(), pContext);
        pDevice->RW_byte_fesa.set( pPLCDevice->getRegister("RW_byte")->getVal<uint8_t>(), pContext);
        pDevice->RW_word_fesa.set( pPLCDevice->getRegister("RW_word")->getVal<uint16_t>(), pContext);
        pDevice->RW_dword_fesa.set( pPLCDevice->getRegister("RW_dword")->getVal<uint32_t>(), pContext);
        pDevice->RW_int_fesa.set( pPLCDevice->getRegister("RW_int")->getVal<int16_t>(), pContext);
        pDevice->RW_dint_fesa.set( pPLCDevice->getRegister("RW_dint")->getVal<int32_t>(), pContext);
        pDevice->RW_real_fesa.set( pPLCDevice->getRegister("RW_real")->getVal<float>(), pContext);
        pDevice->RW_dt_fesa.set( pPLCDevice->getRegister("RW_dt")->getVal<double>(), pContext);
        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_int8.set(pRegister->getRefArray2D<int8_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint8");
            uint32_t dim1;
            uint32_t dim2;
            uint8_t* data = pRegister->getRefArray2D<uint8_t>(dim1, dim2);
            std::vector<int16_t> RW2_uint8(data, data + dim1 * dim2);
            pDevice->RW2_uint8_fesa.set(RW2_uint8.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_int16_fesa.set(pRegister->getRefArray2D<int16_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint16");
            uint32_t dim1;
            uint32_t dim2;
            uint16_t* data = pRegister->getRefArray2D<uint16_t>(dim1, dim2);
            std::vector<int32_t> RW2_uint16(data, data + dim1 * dim2);
            pDevice->RW2_uint16_fesa.set(RW2_uint16.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_int32_fesa.set(pRegister->getRefArray2D<int32_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint32");
            uint32_t dim1;
            uint32_t dim2;
            uint32_t* data = pRegister->getRefArray2D<uint32_t>(dim1, dim2);
            std::vector<int64_t> RW2_uint32(data, data + dim1 * dim2);
            pDevice->RW2_uint32_fesa.set(RW2_uint32.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_float32_fesa.set(pRegister->getRefArray2D<float>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_date_fesa.set(pRegister->getRefArray2D<double>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_char_fesa.set(pRegister->getRefArray2D<int8_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_byte");
            uint32_t dim1;
            uint32_t dim2;
            uint8_t* data = pRegister->getRefArray2D<uint8_t>(dim1, dim2);
            std::vector<int16_t> RW2_byte(data, data + dim1 * dim2);
            pDevice->RW2_byte_fesa.set(RW2_byte.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_word");
            uint32_t dim1;
            uint32_t dim2;
            uint16_t* data = pRegister->getRefArray2D<uint16_t>(dim1, dim2);
            std::vector<int32_t> RW2_word(data, data + dim1 * dim2);
            pDevice->RW2_word_fesa.set(RW2_word.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dword");
            uint32_t dim1;
            uint32_t dim2;
            uint32_t* data = pRegister->getRefArray2D<uint32_t>(dim1, dim2);
            std::vector<int64_t> RW2_dword(data, data + dim1 * dim2);
            pDevice->RW2_dword_fesa.set(RW2_dword.data(), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_int_fesa.set(pRegister->getRefArray2D<int16_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_dint_fesa.set(pRegister->getRefArray2D<int32_t>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_real_fesa.set(pRegister->getRefArray2D<float>(dim1, dim2), dim1, dim2, pContext);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            pDevice->RW2_dt_fesa.set(pRegister->getRefArray2D<double>(dim1, dim2), dim1, dim2, pContext);
        }

    }
    
    void MyRWBlock_Type::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC  = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        pPLCDevice->getRegister("RW_int8")->setVal<int8_t>( pDevice->RW_int8.get(pContext));
        pPLCDevice->getRegister("RW_uint8")->setVal<uint8_t>( (uint8_t)pDevice->RW_uint8_fesa.get(pContext));
        pPLCDevice->getRegister("RW_int16")->setVal<int16_t>( pDevice->RW_int16_fesa.get(pContext));
        pPLCDevice->getRegister("RW_uint16")->setVal<uint16_t>( (uint16_t)pDevice->RW_uint16_fesa.get(pContext));
        pPLCDevice->getRegister("RW_int32")->setVal<int32_t>( pDevice->RW_int32_fesa.get(pContext));
        pPLCDevice->getRegister("RW_uint32")->setVal<uint32_t>( (uint32_t)pDevice->RW_uint32_fesa.get(pContext));
        pPLCDevice->getRegister("RW_float32")->setVal<float>( pDevice->RW_float32_fesa.get(pContext));
        pPLCDevice->getRegister("RW_string")->setVal<std::string>(pDevice->RW_string_fesa.get(pContext));

        pPLCDevice->getRegister("RW_date")->setVal<double>( pDevice->RW_date_fesa.get(pContext));
        pPLCDevice->getRegister("RW_char")->setVal<int8_t>( pDevice->RW_char_fesa.get(pContext));
        pPLCDevice->getRegister("RW_byte")->setVal<uint8_t>( (uint8_t)pDevice->RW_byte_fesa.get(pContext));
        pPLCDevice->getRegister("RW_word")->setVal<uint16_t>( (uint16_t)pDevice->RW_word_fesa.get(pContext));
        pPLCDevice->getRegister("RW_dword")->setVal<uint32_t>( (uint32_t)pDevice->RW_dword_fesa.get(pContext));
        pPLCDevice->getRegister("RW_int")->setVal<int16_t>( pDevice->RW_int_fesa.get(pContext));
        pPLCDevice->getRegister("RW_dint")->setVal<int32_t>( pDevice->RW_dint_fesa.get(pContext));
        pPLCDevice->getRegister("RW_real")->setVal<float>( pDevice->RW_real_fesa.get(pContext));
        pPLCDevice->getRegister("RW_dt")->setVal<double>( pDevice->RW_dt_fesa.get(pContext));
        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int8_t>(pDevice->RW2_int8.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* RW2_uint8 = pDevice->RW2_uint8_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint8_t> data(RW2_uint8, RW2_uint8 + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int16_t>(pDevice->RW2_int16_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* RW2_uint16 = pDevice->RW2_uint16_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint16_t> data(RW2_uint16, RW2_uint16 + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int32_t>(pDevice->RW2_int32_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* RW2_uint32 = pDevice->RW2_uint32_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint32_t> data(RW2_uint32, RW2_uint32 + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<float>(pDevice->RW2_float32_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<double>(pDevice->RW2_date_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int8_t>(pDevice->RW2_char_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_byte");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* RW2_byte = pDevice->RW2_byte_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint8_t> data(RW2_byte, RW2_byte + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_word");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* RW2_word = pDevice->RW2_word_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint16_t> data(RW2_word, RW2_word + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dword");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* RW2_dword = pDevice->RW2_dword_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint32_t> data(RW2_dword, RW2_dword + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int16_t>(pDevice->RW2_int_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int32_t>(pDevice->RW2_dint_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<float>(pDevice->RW2_real_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<double>(pDevice->RW2_dt_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        if (sendNow) pPLCDevice->send(blockName_);
    }

    void MyRWBlock_Type::setOneDevice(Device* pDevice, const MyRWBlockPropPropertyData& data, bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        (data.isRW_int8Available()) ? pPLCDevice->getRegister("RW_int8")->setVal<int8_t>( data.RW_int8.get()) :
                                          pPLCDevice->getRegister("RW_int8")->setVal<int8_t>( pDevice->RW_int8.get(pContext));
        (data.isRW_uint8_fesaAvailable()) ? pPLCDevice->getRegister("RW_uint8")->setVal<uint8_t>( (uint8_t)data.RW_uint8_fesa.get()) :
                                          pPLCDevice->getRegister("RW_uint8")->setVal<uint8_t>( (uint8_t)pDevice->RW_uint8_fesa.get(pContext));
        (data.isRW_int16_fesaAvailable()) ? pPLCDevice->getRegister("RW_int16")->setVal<int16_t>( data.RW_int16_fesa.get()) :
                                          pPLCDevice->getRegister("RW_int16")->setVal<int16_t>( pDevice->RW_int16_fesa.get(pContext));
        (data.isRW_uint16_fesaAvailable()) ? pPLCDevice->getRegister("RW_uint16")->setVal<uint16_t>( (uint16_t)data.RW_uint16_fesa.get()) :
                                          pPLCDevice->getRegister("RW_uint16")->setVal<uint16_t>( (uint16_t)pDevice->RW_uint16_fesa.get(pContext));
        (data.isRW_int32_fesaAvailable()) ? pPLCDevice->getRegister("RW_int32")->setVal<int32_t>( data.RW_int32_fesa.get()) :
                                          pPLCDevice->getRegister("RW_int32")->setVal<int32_t>( pDevice->RW_int32_fesa.get(pContext));
        (data.isRW_uint32_fesaAvailable()) ? pPLCDevice->getRegister("RW_uint32")->setVal<uint32_t>( (uint32_t)data.RW_uint32_fesa.get()) :
                                          pPLCDevice->getRegister("RW_uint32")->setVal<uint32_t>( (uint32_t)pDevice->RW_uint32_fesa.get(pContext));
        (data.isRW_float32_fesaAvailable()) ? pPLCDevice->getRegister("RW_float32")->setVal<float>( data.RW_float32_fesa.get()) :
                                          pPLCDevice->getRegister("RW_float32")->setVal<float>( pDevice->RW_float32_fesa.get(pContext));
        (data.isRW_string_fesaAvailable()) ? pPLCDevice->getRegister("RW_string")->setVal<std::string>(data.RW_string_fesa.get()) :
                                     pPLCDevice->getRegister("RW_string")->setVal<std::string>(pDevice->RW_string_fesa.get(pContext));
        (data.isRW_date_fesaAvailable()) ? pPLCDevice->getRegister("RW_date")->setVal<double>( data.RW_date_fesa.get()) :
                                          pPLCDevice->getRegister("RW_date")->setVal<double>( pDevice->RW_date_fesa.get(pContext));
        (data.isRW_char_fesaAvailable()) ? pPLCDevice->getRegister("RW_char")->setVal<int8_t>( data.RW_char_fesa.get()) :
                                          pPLCDevice->getRegister("RW_char")->setVal<int8_t>( pDevice->RW_char_fesa.get(pContext));
        (data.isRW_byte_fesaAvailable()) ? pPLCDevice->getRegister("RW_byte")->setVal<uint8_t>( (uint8_t)data.RW_byte_fesa.get()) :
                                          pPLCDevice->getRegister("RW_byte")->setVal<uint8_t>( (uint8_t)pDevice->RW_byte_fesa.get(pContext));
        (data.isRW_word_fesaAvailable()) ? pPLCDevice->getRegister("RW_word")->setVal<uint16_t>( (uint16_t)data.RW_word_fesa.get()) :
                                          pPLCDevice->getRegister("RW_word")->setVal<uint16_t>( (uint16_t)pDevice->RW_word_fesa.get(pContext));
        (data.isRW_dword_fesaAvailable()) ? pPLCDevice->getRegister("RW_dword")->setVal<uint32_t>( (uint32_t)data.RW_dword_fesa.get()) :
                                          pPLCDevice->getRegister("RW_dword")->setVal<uint32_t>( (uint32_t)pDevice->RW_dword_fesa.get(pContext));
        (data.isRW_int_fesaAvailable()) ? pPLCDevice->getRegister("RW_int")->setVal<int16_t>( data.RW_int_fesa.get()) :
                                          pPLCDevice->getRegister("RW_int")->setVal<int16_t>( pDevice->RW_int_fesa.get(pContext));
        (data.isRW_dint_fesaAvailable()) ? pPLCDevice->getRegister("RW_dint")->setVal<int32_t>( data.RW_dint_fesa.get()) :
                                          pPLCDevice->getRegister("RW_dint")->setVal<int32_t>( pDevice->RW_dint_fesa.get(pContext));
        (data.isRW_real_fesaAvailable()) ? pPLCDevice->getRegister("RW_real")->setVal<float>( data.RW_real_fesa.get()) :
                                          pPLCDevice->getRegister("RW_real")->setVal<float>( pDevice->RW_real_fesa.get(pContext));
        (data.isRW_dt_fesaAvailable()) ? pPLCDevice->getRegister("RW_dt")->setVal<double>( data.RW_dt_fesa.get()) :
                                          pPLCDevice->getRegister("RW_dt")->setVal<double>( pDevice->RW_dt_fesa.get(pContext));
        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_int8Available()) ? pRegister->setValArray2D<int8_t>(data.RW2_int8.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int8_t>(pDevice->RW2_int8.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* RW2_uint8;
            (data.isRW2_uint8_fesaAvailable()) ? RW2_uint8 = data.RW2_uint8_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_uint8 = pDevice->RW2_uint8_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint8_t> data(RW2_uint8, RW2_uint8 + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_int16_fesaAvailable()) ? pRegister->setValArray2D<int16_t>(data.RW2_int16_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int16_t>(pDevice->RW2_int16_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* RW2_uint16;
            (data.isRW2_uint16_fesaAvailable()) ? RW2_uint16 = data.RW2_uint16_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_uint16 = pDevice->RW2_uint16_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint16_t> data(RW2_uint16, RW2_uint16 + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_int32_fesaAvailable()) ? pRegister->setValArray2D<int32_t>(data.RW2_int32_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int32_t>(pDevice->RW2_int32_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_uint32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* RW2_uint32;
            (data.isRW2_uint32_fesaAvailable()) ? RW2_uint32 = data.RW2_uint32_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_uint32 = pDevice->RW2_uint32_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint32_t> data(RW2_uint32, RW2_uint32 + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_float32_fesaAvailable()) ? pRegister->setValArray2D<float>(data.RW2_float32_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<float>(pDevice->RW2_float32_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_date_fesaAvailable()) ? pRegister->setValArray2D<double>(data.RW2_date_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<double>(pDevice->RW2_date_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_char_fesaAvailable()) ? pRegister->setValArray2D<int8_t>(data.RW2_char_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int8_t>(pDevice->RW2_char_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_byte");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* RW2_byte;
            (data.isRW2_byte_fesaAvailable()) ? RW2_byte = data.RW2_byte_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_byte = pDevice->RW2_byte_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint8_t> data(RW2_byte, RW2_byte + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_word");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* RW2_word;
            (data.isRW2_word_fesaAvailable()) ? RW2_word = data.RW2_word_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_word = pDevice->RW2_word_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint16_t> data(RW2_word, RW2_word + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dword");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* RW2_dword;
            (data.isRW2_dword_fesaAvailable()) ? RW2_dword = data.RW2_dword_fesa.get(fesaDim1, fesaDim2) :
                                        RW2_dword = pDevice->RW2_dword_fesa.get(fesaDim1, fesaDim2, pContext);
            std::vector<uint32_t> data(RW2_dword, RW2_dword + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_int_fesaAvailable()) ? pRegister->setValArray2D<int16_t>(data.RW2_int_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int16_t>(pDevice->RW2_int_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_dint_fesaAvailable()) ? pRegister->setValArray2D<int32_t>(data.RW2_dint_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int32_t>(pDevice->RW2_dint_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_real_fesaAvailable()) ? pRegister->setValArray2D<float>(data.RW2_real_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<float>(pDevice->RW2_real_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("RW2_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isRW2_dt_fesaAvailable()) ? pRegister->setValArray2D<double>(data.RW2_dt_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<double>(pDevice->RW2_dt_fesa.get(fesaDim1, fesaDim2, pContext), dim1, dim2);
        }

        if (sendNow) pPLCDevice->send(blockName_);

    }
    
    void MyWOBlock_Type::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC  = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        {
            auto& pRegister = pPLCDevice->getRegister("WO_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int8_t>(pDevice->WO_int8.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint8");
            uint32_t fesaDim1;
            const int16_t* WO_uint8 = pDevice->WO_uint8_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint8_t> data(WO_uint8, WO_uint8 + dim1);
            pRegister->setValArray<uint8_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int16_t>(pDevice->WO_int16_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint16");
            uint32_t fesaDim1;
            const int32_t* WO_uint16 = pDevice->WO_uint16_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint16_t> data(WO_uint16, WO_uint16 + dim1);
            pRegister->setValArray<uint16_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int32_t>(pDevice->WO_int32_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint32");
            uint32_t fesaDim1;
            const int64_t* WO_uint32 = pDevice->WO_uint32_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint32_t> data(WO_uint32, WO_uint32 + dim1);
            pRegister->setValArray<uint32_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<float>(pDevice->WO_float32_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_string");
            uint32_t dim1 = pRegister->getDimension1();
            std::string stdStringArray[dim1];
            uint32_t fesaDim1;
            const char* const* cStringArray = pDevice->WO_string_fesa.get(fesaDim1, pContext);
            for (unsigned int i=0; i<dim1; i++) stdStringArray[i] = (const char*)cStringArray[i];
            pRegister->setValArray<std::string>(stdStringArray, dim1);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("WO_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<double>(pDevice->WO_date_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int8_t>(pDevice->WO_char_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_byte");
            uint32_t fesaDim1;
            const int16_t* WO_byte = pDevice->WO_byte_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint8_t> data(WO_byte, WO_byte + dim1);
            pRegister->setValArray<uint8_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_word");
            uint32_t fesaDim1;
            const int32_t* WO_word = pDevice->WO_word_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint16_t> data(WO_word, WO_word + dim1);
            pRegister->setValArray<uint16_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dword");
            uint32_t fesaDim1;
            const int64_t* WO_dword = pDevice->WO_dword_fesa.get(fesaDim1, pContext);
            uint32_t dim1 = pRegister->getDimension1();
            std::vector<uint32_t> data(WO_dword, WO_dword + dim1);
            pRegister->setValArray<uint32_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int16_t>(pDevice->WO_int_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<int32_t>(pDevice->WO_dint_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<float>(pDevice->WO_real_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            pRegister->setValArray<double>(pDevice->WO_dt_fesa.get(fesaDim1, pContext), dim1);
        }
    
        if (sendNow) pPLCDevice->send(blockName_);
    }

    void MyWOBlock_Type::setOneDevice(Device* pDevice, const MyWOBlockPropPropertyData& data, bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        {
            auto& pRegister = pPLCDevice->getRegister("WO_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_int8Available()) ? pRegister->setValArray<int8_t>( data.WO_int8.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int8_t>( pDevice->WO_int8.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int16_t* WO_uint8;
            (data.isWO_uint8_fesaAvailable()) ? WO_uint8 = data.WO_uint8_fesa.get(fesaDim1) :
                                        WO_uint8 = pDevice->WO_uint8_fesa.get(fesaDim1, pContext);
            std::vector<uint8_t> data(WO_uint8, WO_uint8 + dim1);
            pRegister->setValArray<uint8_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_int16_fesaAvailable()) ? pRegister->setValArray<int16_t>( data.WO_int16_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int16_t>( pDevice->WO_int16_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int32_t* WO_uint16;
            (data.isWO_uint16_fesaAvailable()) ? WO_uint16 = data.WO_uint16_fesa.get(fesaDim1) :
                                        WO_uint16 = pDevice->WO_uint16_fesa.get(fesaDim1, pContext);
            std::vector<uint16_t> data(WO_uint16, WO_uint16 + dim1);
            pRegister->setValArray<uint16_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_int32_fesaAvailable()) ? pRegister->setValArray<int32_t>( data.WO_int32_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int32_t>( pDevice->WO_int32_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_uint32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int64_t* WO_uint32;
            (data.isWO_uint32_fesaAvailable()) ? WO_uint32 = data.WO_uint32_fesa.get(fesaDim1) :
                                        WO_uint32 = pDevice->WO_uint32_fesa.get(fesaDim1, pContext);
            std::vector<uint32_t> data(WO_uint32, WO_uint32 + dim1);
            pRegister->setValArray<uint32_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_float32_fesaAvailable()) ? pRegister->setValArray<float>( data.WO_float32_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<float>( pDevice->WO_float32_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_string");
            uint32_t dim1 = pRegister->getDimension1();
            std::string stdStringArray[dim1];
            uint32_t fesaDim1;
            const char* const* cStringArray = (data.isWO_string_fesaAvailable() ? data.WO_string_fesa.get(fesaDim1) : pDevice->WO_string_fesa.get(fesaDim1, pContext));
            for (unsigned int i=0; i<dim1; i++) stdStringArray[i] = (const char*)cStringArray[i];
            pRegister->setValArray<std::string>(stdStringArray, dim1);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("WO_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_date_fesaAvailable()) ? pRegister->setValArray<double>( data.WO_date_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<double>( pDevice->WO_date_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_char_fesaAvailable()) ? pRegister->setValArray<int8_t>( data.WO_char_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int8_t>( pDevice->WO_char_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_byte");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int16_t* WO_byte;
            (data.isWO_byte_fesaAvailable()) ? WO_byte = data.WO_byte_fesa.get(fesaDim1) :
                                        WO_byte = pDevice->WO_byte_fesa.get(fesaDim1, pContext);
            std::vector<uint8_t> data(WO_byte, WO_byte + dim1);
            pRegister->setValArray<uint8_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_word");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int32_t* WO_word;
            (data.isWO_word_fesaAvailable()) ? WO_word = data.WO_word_fesa.get(fesaDim1) :
                                        WO_word = pDevice->WO_word_fesa.get(fesaDim1, pContext);
            std::vector<uint16_t> data(WO_word, WO_word + dim1);
            pRegister->setValArray<uint16_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dword");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            const int64_t* WO_dword;
            (data.isWO_dword_fesaAvailable()) ? WO_dword = data.WO_dword_fesa.get(fesaDim1) :
                                        WO_dword = pDevice->WO_dword_fesa.get(fesaDim1, pContext);
            std::vector<uint32_t> data(WO_dword, WO_dword + dim1);
            pRegister->setValArray<uint32_t>(data.data(), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_int_fesaAvailable()) ? pRegister->setValArray<int16_t>( data.WO_int_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int16_t>( pDevice->WO_int_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_dint_fesaAvailable()) ? pRegister->setValArray<int32_t>( data.WO_dint_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<int32_t>( pDevice->WO_dint_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_real_fesaAvailable()) ? pRegister->setValArray<float>( data.WO_real_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<float>( pDevice->WO_real_fesa.get(fesaDim1, pContext), dim1);
        }
    
        {
            auto& pRegister = pPLCDevice->getRegister("WO_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t fesaDim1;
            (data.isWO_dt_fesaAvailable()) ? pRegister->setValArray<double>( data.WO_dt_fesa.get(fesaDim1), dim1) :
                                        pRegister->setValArray<double>( pDevice->WO_dt_fesa.get(fesaDim1, pContext), dim1);
        }
    
        if (sendNow) pPLCDevice->send(blockName_);

    }
    
    void MyCBlock_Type::setOneDevice(Device* pDevice, const bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC  = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        {
            auto& pRegister = pPLCDevice->getRegister("C_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int8_t>(pDevice->C_int8.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* C_uint8 = pDevice->C_uint8_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint8_t> data(C_uint8, C_uint8 + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int16_t>(pDevice->C_int16_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* C_uint16 = pDevice->C_uint16_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint16_t> data(C_uint16, C_uint16 + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int32_t>(pDevice->C_int32_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* C_uint32 = pDevice->C_uint32_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint32_t> data(C_uint32, C_uint32 + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<float>(pDevice->C_float32_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<double>(pDevice->C_date_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int8_t>(pDevice->C_char_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_byte");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* C_byte = pDevice->C_byte_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint8_t> data(C_byte, C_byte + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_word");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* C_word = pDevice->C_word_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint16_t> data(C_word, C_word + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dword");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* C_dword = pDevice->C_dword_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint32_t> data(C_dword, C_dword + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int16_t>(pDevice->C_int_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<int32_t>(pDevice->C_dint_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<float>(pDevice->C_real_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            pRegister->setValArray2D<double>(pDevice->C_dt_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        if (sendNow) pPLCDevice->send(blockName_);
    }

    void MyCBlock_Type::setOneDevice(Device* pDevice, const MyCBlockPropPropertyData& data, bool sendNow, MultiplexingContext* pContext)
    {
        checkInitialized();
        Silecs::PLC* pPLC = &pPLCHandler_->getPLC(pDevice->plcHostName.get());
        Silecs::Device* pPLCDevice = pPLC->getDeploy().getDesign("AllTypes").getDevice(pDevice->plcDeviceLabel.get());

        {
            auto& pRegister = pPLCDevice->getRegister("C_int8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_int8Available()) ? pRegister->setValArray2D<int8_t>(data.C_int8.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int8_t>(pDevice->C_int8.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint8");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* C_uint8;
            (data.isC_uint8_fesaAvailable()) ? C_uint8 = data.C_uint8_fesa.get(fesaDim1, fesaDim2) :
                                        C_uint8 = pDevice->C_uint8_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint8_t> data(C_uint8, C_uint8 + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_int16_fesaAvailable()) ? pRegister->setValArray2D<int16_t>(data.C_int16_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int16_t>(pDevice->C_int16_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint16");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* C_uint16;
            (data.isC_uint16_fesaAvailable()) ? C_uint16 = data.C_uint16_fesa.get(fesaDim1, fesaDim2) :
                                        C_uint16 = pDevice->C_uint16_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint16_t> data(C_uint16, C_uint16 + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_int32_fesaAvailable()) ? pRegister->setValArray2D<int32_t>(data.C_int32_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int32_t>(pDevice->C_int32_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_uint32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* C_uint32;
            (data.isC_uint32_fesaAvailable()) ? C_uint32 = data.C_uint32_fesa.get(fesaDim1, fesaDim2) :
                                        C_uint32 = pDevice->C_uint32_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint32_t> data(C_uint32, C_uint32 + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_float32");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_float32_fesaAvailable()) ? pRegister->setValArray2D<float>(data.C_float32_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<float>(pDevice->C_float32_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_date");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_date_fesaAvailable()) ? pRegister->setValArray2D<double>(data.C_date_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<double>(pDevice->C_date_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_char");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_char_fesaAvailable()) ? pRegister->setValArray2D<int8_t>(data.C_char_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int8_t>(pDevice->C_char_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_byte");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int16_t* C_byte;
            (data.isC_byte_fesaAvailable()) ? C_byte = data.C_byte_fesa.get(fesaDim1, fesaDim2) :
                                        C_byte = pDevice->C_byte_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint8_t> data(C_byte, C_byte + dim1 * dim2);
            pRegister->setValArray2D<uint8_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_word");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int32_t* C_word;
            (data.isC_word_fesaAvailable()) ? C_word = data.C_word_fesa.get(fesaDim1, fesaDim2) :
                                        C_word = pDevice->C_word_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint16_t> data(C_word, C_word + dim1 * dim2);
            pRegister->setValArray2D<uint16_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dword");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            const int64_t* C_dword;
            (data.isC_dword_fesaAvailable()) ? C_dword = data.C_dword_fesa.get(fesaDim1, fesaDim2) :
                                        C_dword = pDevice->C_dword_fesa.get(fesaDim1, fesaDim2);
            std::vector<uint32_t> data(C_dword, C_dword + dim1 * dim2);
            pRegister->setValArray2D<uint32_t>(data.data(), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_int");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_int_fesaAvailable()) ? pRegister->setValArray2D<int16_t>(data.C_int_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int16_t>(pDevice->C_int_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dint");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_dint_fesaAvailable()) ? pRegister->setValArray2D<int32_t>(data.C_dint_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<int32_t>(pDevice->C_dint_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_real");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_real_fesaAvailable()) ? pRegister->setValArray2D<float>(data.C_real_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<float>(pDevice->C_real_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        {
            auto& pRegister = pPLCDevice->getRegister("C_dt");
            uint32_t dim1 = pRegister->getDimension1();
            uint32_t dim2 = pRegister->getDimension2();
            uint32_t fesaDim1,fesaDim2;
            (data.isC_dt_fesaAvailable()) ? pRegister->setValArray2D<double>(data.C_dt_fesa.get(fesaDim1, fesaDim2), dim1, dim2) :
                                         pRegister->setValArray2D<double>(pDevice->C_dt_fesa.get(fesaDim1, fesaDim2), dim1, dim2);
        }

        if (sendNow) pPLCDevice->send(blockName_);

    }

}
