
/* +-------------------------------------------------------------------
 * | Copyright CERN 2015
 * | SILECS - BE/CO-SRC
 * | April 2015
 * +-------------------------------------------------------------------
 *
 * Release : DEV
 *
 * The following code has been automatically generated by SILECS.
 * Code regeneration will overwrite it.
 *
 * N.B: This file relies on the existence of explicit C data type such
 * as int8_t, uint8_t, int16_t, etc....
 * If your compiler does not support them natively please implement 
 * them by including the data type definition provided on the SILECS
 * web page before including this header file.
 */

#define MODBUS_START_ADDRESS 0

/*---------------------------------------------------------------------
 * DT 
 * data type definition and related utilities
 *---------------------------------------------------------------------
 */

typedef struct
{
    uint8_t sc_100;     // second cent
    uint8_t sc;            // second
    uint8_t mn;         // minute
    uint8_t hh;         // hour
    uint8_t dd;         // day
    uint8_t mm;         // month
    uint8_t yy1;        // year
    uint8_t yy2;        // year2
} dt;

#define _frombcd(a) (int)(((a>>4)*10)+(a&0x0F))
#define _tobcd(a)   (((unsigned char)((a)/10)<<4)+((a)%10))

void SILECS_set_dt(int8_t sc_100 ,int8_t sc, int8_t mn,int8_t hh,int8_t dd,int8_t mm,int32_t yy, dt *date)
{
    date->sc_100 = sc_100;
    date->sc     = _tobcd(sc);
    date->mn     = _tobcd(mn);
    date->hh     = _tobcd(hh);
    date->dd     = _tobcd(dd);
    date->mm     = _tobcd(mm);
    date->yy2    = _tobcd((int8_t)(yy/100));
    date->yy1    = _tobcd((int8_t)(yy%100));
}


/*---------------------------------------------------------------------
 * SilecsHeader / v1.0.0
 * BLOCK Type definition
 *---------------------------------------------------------------------
 */

typedef struct 
{
    uint8_t _version[16];
    uint32_t _checksum;
    uint8_t _user[16];
    dt _date;

} _SilecsHeader_hdrBlk;

/*---------------------------------------------------------------------
 * AllTypes / v0.1.0
 * BLOCK Type definition
 *---------------------------------------------------------------------
 */

typedef struct 
{
    int16_t RO_int8;
    uint16_t RO_uint8;
    int16_t RO_int16;
    uint16_t RO_uint16;
    int32_t RO_int32;
    uint32_t RO_uint32;
    float RO_float32;
    uint8_t RO_string[64];
    dt RO_date;
    int16_t RO_char;
    uint16_t RO_byte;
    uint16_t RO_word;
    uint32_t RO_dword;
    int16_t RO_int;
    int32_t RO_dint;
    float RO_real;
    dt RO_dt;

} _AllTypes_MyROBlock;

typedef struct 
{
    int16_t RW_int8;
    uint16_t RW_uint8;
    int16_t RW_int16;
    uint16_t RW_uint16;
    int32_t RW_int32;
    uint32_t RW_uint32;
    float RW_float32;
    uint8_t RW_string[64];
    dt RW_date;
    int16_t RW_char;
    uint16_t RW_byte;
    uint16_t RW_word;
    uint32_t RW_dword;
    int16_t RW_int;
    int32_t RW_dint;
    float RW_real;
    dt RW_dt;
    int16_t RW2_int8[2][2];
    uint16_t RW2_uint8[2][2];
    int16_t RW2_int16[2][2];
    uint16_t RW2_uint16[2][2];
    int32_t RW2_int32[2][2];
    uint32_t RW2_uint32[2][2];
    float RW2_float32[2][2];
    dt RW2_date[2][2];
    int16_t RW2_char[2][2];
    uint16_t RW2_byte[2][2];
    uint16_t RW2_word[2][2];
    uint32_t RW2_dword[2][2];
    int16_t RW2_int[2][2];
    int32_t RW2_dint[2][2];
    float RW2_real[2][2];
    dt RW2_dt[2][2];

} _AllTypes_MyRWBlock;

typedef struct 
{
    int16_t WO_int8[10];
    uint16_t WO_uint8[10];
    int16_t WO_int16[10];
    uint16_t WO_uint16[10];
    int32_t WO_int32[10];
    uint32_t WO_uint32[10];
    float WO_float32[10];
    uint8_t WO_string[10][64];
    dt WO_date[10];
    int16_t WO_char[10];
    uint16_t WO_byte[10];
    uint16_t WO_word[10];
    uint32_t WO_dword[10];
    int16_t WO_int[10];
    int32_t WO_dint[10];
    float WO_real[10];
    dt WO_dt[10];

} _AllTypes_MyWOBlock;

typedef struct 
{
    int16_t C_int8[2][2];
    uint16_t C_uint8[2][2];
    int16_t C_int16[2][2];
    uint16_t C_uint16[2][2];
    int32_t C_int32[2][2];
    uint32_t C_uint32[2][2];
    float C_float32[2][2];
    uint8_t C_string[2][2][64];
    dt C_date[2][2];
    int16_t C_char[2][2];
    uint16_t C_byte[2][2];
    uint16_t C_word[2][2];
    uint32_t C_dword[2][2];
    int16_t C_int[2][2];
    int32_t C_dint[2][2];
    float C_real[2][2];
    dt C_dt[2][2];

} _AllTypes_MyCBlock;

/*---------------------------------------------------------------------
 * MEMORY ALLOCATION
 * PROTOCOL: BLOCK_MODE
 *---------------------------------------------------------------------
 */

typedef struct {
    
    struct {
        _SilecsHeader_hdrBlk SilecsHeader;
    } SilecsHeader_hdrBlk;

    struct {
        _AllTypes_MyROBlock testDevice1;
        _AllTypes_MyROBlock testDevice2;
    } AllTypes_MyROBlock;

    struct {
        _AllTypes_MyRWBlock testDevice1;
        _AllTypes_MyRWBlock testDevice2;
    } AllTypes_MyRWBlock;

    struct {
        _AllTypes_MyWOBlock testDevice1;
        _AllTypes_MyWOBlock testDevice2;
    } AllTypes_MyWOBlock;

    struct {
        _AllTypes_MyCBlock testDevice1;
        _AllTypes_MyCBlock testDevice2;
    } AllTypes_MyCBlock;

} _SILECS_DATA_SEGMENT;

#define SILECS_DATA_SEGMENT_MODBUS_SIZE (sizeof(_SILECS_DATA_SEGMENT)/2)

union modbus_data {
    _SILECS_DATA_SEGMENT data;
    uint16_t array[SILECS_DATA_SEGMENT_MODBUS_SIZE];
} silecsData;


/* Initialization function */
int SILECS_init()
{
    /* Silecs version initialization */
    strcpy((unsigned char *)silecsData.data.SilecsHeader_hdrBlk.device[0]._version, "SILECS_DEV");
    
    /* Silecs checksum initialization */
    silecsData.data.SilecsHeader_hdrBlk.device[0]._checksum  = 1058313111;
    
    /* Silecs user initialization */
    strcpy((unsigned char *)silecsData.data.SilecsHeader_hdrBlk.device[0]._user, "schwinn");
    
    /* Silecs date initialization */
    SILECS_set_dt(2,28,6,17,31,1,2018,&silecsData.data.SilecsHeader_hdrBlk.device[0]._date);
}

/*
 * Automatically generated Addressing example
 *
 * This example shows how to address the register C_dt of block MyCBlock
 * of device testDevice2 of the class AllTypes
 *
 *  silecsData.AllTypes_MyCBlock.testDevice2.C_dt = ....;
 */